package net.t2code.autoresponse.Spigot.system;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Util;
import net.t2code.autoresponse.Spigot.cmdManagement.CmdExecuter;
import net.t2code.autoresponse.Spigot.config.config.CreateConfig;
import net.t2code.autoresponse.Spigot.config.config.SelectConfig;
import net.t2code.autoresponse.Spigot.config.languages.CreateMessages;
import net.t2code.autoresponse.Spigot.config.languages.SelectMessages;
import net.t2code.autoresponse.Spigot.config.response.CreateExampleResponse;
import net.t2code.autoresponse.Spigot.config.response.SelectResponses;
import net.t2code.autoresponse.Spigot.event.ResponseListener;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CLibConfig;
import org.bukkit.Bukkit;

import java.util.List;

public class Load {
    static Main plugin = Main.getPlugin();
    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {
        Long long_ = T2Ctemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        plugin.getCommand("t2code-autoresponse").setExecutor( new CmdExecuter());

        loadReload();
        T2CupdateAPI.onUpdateCheck(plugin, prefix,Util.getGit(), spigotID, discord,
                SelectConfig.updateCheckOnJoin,SelectConfig.updateCheckSeePreReleaseUpdates,SelectConfig.updateCheckTimeInterval);
        Bukkit.getServer().getPluginManager().registerEvents(new JoinEvent(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ResponseListener(), plugin);

        T2Ctemplate.onLoadFooter(prefix, long_,version);
        Metrics.Bstats(plugin, bstatsID);
        if (T2CLibConfig.getBungee()) {
            plugin.getServer().getMessenger().registerOutgoingPluginChannel(plugin, "BungeeCord");
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2car:bungee");
        }
        Permissions.register();
    }

    public static void loadReload() {
        CreateConfig.configCreate();
        CreateMessages.langCreate();
        CreateExampleResponse.configCreate();

        SelectConfig.onSelect();
        SelectMessages.onSelect(Util.getPrefix());
        SelectResponses.onSelect();
    }
}
