package net.t2code.autoresponse.Spigot.config.config;

import net.t2code.autoresponse.Spigot.Main;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class SelectConfig {
    public static String language;
    public static Boolean updateCheckOnJoin;
    public static Boolean updateCheckSeePreReleaseUpdates;
    public static Integer updateCheckTimeInterval;
    public static String keywordSeperation;
    public static Boolean logConsole;

    public static void onSelect() {
        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        language = yamlConfiguration.getString("Plugin.language");
        updateCheckOnJoin = yamlConfiguration.getBoolean("Plugin.updateCheck.onJoin");
        updateCheckSeePreReleaseUpdates = yamlConfiguration.getBoolean("Plugin.updateCheck.seePreReleaseUpdates");
        updateCheckTimeInterval = yamlConfiguration.getInt("Plugin.updateCheck.timeInterval");
        keywordSeperation = yamlConfiguration.getString("Plugin.responseKeys.keywordSeperation");

        logConsole = yamlConfiguration.getBoolean("Log.Console.Enable");
    }
}
