package net.t2code.autoresponse.Spigot.config.languages;

import net.t2code.autoresponse.Util;
import net.t2code.autoresponse.Spigot.config.config.SelectConfig;
import net.t2code.autoresponse.Spigot.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class SelectMessages {
    private static String prefix = Util.getPrefix();

    public static String selectMSG;

    public static String OnlyForPlayer;
    public static String ReloadStart;
    public static String ReloadEnd;

    public static String NoPermissionForCommand;
    public static String AliasDisabled;


    public static void onSelect(String Prefix) {

        T2Csend.debug(Main.getPlugin(), "§4Select language...");
        long long_ = System.currentTimeMillis();

        File msg;

        msg = new File(Main.getPath(), "languages/" + SelectConfig.language + "_messages.yml");
        if (!msg.isFile()) {
            T2Csend.console(Prefix);
            T2Csend.console(Prefix + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Prefix + " §4The selected §c" + SelectConfig.language + " §4language file was not found.");
            T2Csend.console(Prefix + " §6The default language §eEnglish §6is used!");
            T2Csend.console(Prefix + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Prefix);
            msg = new File(Main.getPath(), "languages/" + "english_messages.yml");
            selectMSG = "english";
        } else selectMSG = SelectConfig.language;
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(msg);

        ReloadStart = T2Cconfig.select(prefix, "Plugin.Reload.Start", yamlConfiguration);
        ReloadEnd = T2Cconfig.select(prefix, "Plugin.Reload.End", yamlConfiguration);
        NoPermissionForCommand = T2Cconfig.select(prefix, "Plugin.ForCommand", yamlConfiguration);

        T2Csend.console(Prefix + " §2Language successfully selected to: §6" + selectMSG  + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }
}
